package com.example.lolo.conversordivisas;

import android.graphics.Color;
import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

import java.net.URL;
import java.net.URLEncoder;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

public class MainActivity extends AppCompatActivity implements OnClickListener {

    private TextView _lblEntrada;
    private TextView _lblSalida;
    private TextView _txtError;

    private String divisaFrom;
    private String divisaTo;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Inicializar();


    }

    private void Inicializar() {
        try
        {
            _lblEntrada = (TextView)findViewById(R.id.lblEntrada);
            _lblSalida = (TextView) findViewById(R.id.lblResultado);
            _txtError = (TextView) findViewById(R.id.txtError);
            _txtError.setTextColor(Color.RED);

            Spinner spinner = (Spinner) findViewById(R.id.divisaFrom);
            ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this,R.array.divisas_array, android.R.layout.simple_spinner_item);
            adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinner.setAdapter(adapter);
            spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
                    divisaFrom = parentView.getItemAtPosition(position).toString().substring(0, 3);
                }

                @Override
                public void onNothingSelected(AdapterView<?> parentView) {
                    divisaFrom = "";
                }

            });


            spinner = (Spinner) findViewById(R.id.divisaTo);
            adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinner.setAdapter(adapter);
            spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> parentView, View selectedItemView, int position, long id) {
                    divisaTo = parentView.getItemAtPosition(position).toString().substring(0, 3);
                }

                @Override
                public void onNothingSelected(AdapterView<?> parentView) {
                    divisaTo = "";
                }

            });

            Button btn = (Button) findViewById(R.id.btn0);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn1);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn2);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn3);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn4);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn5);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn6);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn7);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn8);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btn9);
            btn.setOnClickListener(this);

            btn = (Button) findViewById(R.id.btnDel);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btnClear);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btnPto);
            btn.setOnClickListener(this);
            btn = (Button) findViewById(R.id.btnConvertir);
            btn.setOnClickListener(this);

        }
        catch (Exception ex)
        {
            Log.e("Divisas", ex.getMessage(), ex);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onClick(View view) {
        String tag = (String) view.getTag();
        switch (tag)
        {
            case "del":
                CharSequence res = _lblEntrada.getText();
                if (res.length() > 0) {
                    _lblEntrada.setText(res.subSequence(0, res.length() - 1));
                }
                break;
            case "clear":
                _lblEntrada.setText("");
                _lblSalida.setText("");
                break;
            case "separator":
                _lblEntrada.setText(_lblEntrada.getText() + ".");
                break;
            case "Convert":
                convertir();
                break;
            default:
                _lblEntrada.setText(_lblEntrada.getText() + tag);
                break;
        }
    }


    private void convertir() {
        try {

            String valorIntroducido = _lblEntrada.getText().toString();
            double ratioConversion = new Conversor().execute("divisa1").get();
          
            String resultado = String.valueOf(Float.parseFloat(valorIntroducido) * ratioConversion);

            _lblSalida.setText(String.valueOf(resultado));
            _txtError.setText("");
        } catch (Exception ex) {
            Log.e("Divisas", ex.getMessage(), ex);
            _txtError.setText("Error en la conversión: " + ex.getMessage());
        }
    }

     Double resultadosSW(String divisa1, String divisa2) throws Exception {
            URL url = new URL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency=" + URLEncoder.encode(divisa1, "UTF-8") + "&ToCurrency="+ URLEncoder.encode(divisa2, "UTF-8") );
            SAXParserFactory fabrica = SAXParserFactory.newInstance();
            SAXParser parser = fabrica.newSAXParser();
            XMLReader lector = parser.getXMLReader();
            ManejadorXML manejadorXML = new ManejadorXML();
            lector.setContentHandler(manejadorXML);
            lector.parse(new InputSource(url.openStream()));
            return manejadorXML.getTotalResults();
    }

    public class Conversor extends AsyncTask<String, Void, Double> {
        @Override
        protected Double doInBackground(String... params) {
            try {
                return resultadosSW(divisaFrom, divisaTo);
            }
            catch (Exception ex){
                Log.e("Divisas", ex.getMessage(), ex);
                return null;
            }
        }
    }


}



